/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.geom.Point;
	import flash.display.DisplayObject;
	import com.actionscriptfacile.ui.text.UITextField;
	
	
	/**
	 * Personnalisation des erreurs.
	 * 
	 * @author Matthieu
	 */
	public class AppliError extends Error
	{
		
		public function AppliError(message : * = "", id : * = 0)
		{
			super(message, id);
		}



		/**
		 * Affiche le message d'erreur 
		 * en conservant la charte graphique de notre application.
		 * 
		 */
		public function showError(oPoint:Point) : DisplayObject
		{
			var oText:UITextField = this.addText( "---> ERREUR : "+message, oPoint);
			
			return oText;
		}

		
						
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String, oPoint:Point) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = true;
			oTxtField.multiline = true;// plusieurs lignes dans le champ texte
			oTxtField.autoSizeLeft();
			
			/* Passage par référence  */
			var oCoord:Point = oPoint;// dans ce cas là, les coordonnées de oPoint sont passées comme une référence à l'objet oCoord
			oTxtField.x = oCoord.x;// les textes sont les uns sous les autres
			oTxtField.y = oCoord.y;
			oCoord.y += 50;// modifie donc les valeurs de oPoint
			
			
			oTxtField.maxHeight = oTxtField.height = 100;
			
			oTxtField.background = true;
			oTxtField.backgroundColor = 0x006f77;
			
			oTxtField.changeFormat("size", 28);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", Math.random()*0xffffff);// changement de la couleur
			
			return oTxtField;	 
		}
	}
}
