﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package 
{
	import flash.display.DisplayObject;
	import flash.geom.Point;
	import com.as3facile.DefaultButton;
	import flash.events.MouseEvent;

	import com.actionscriptfacile.ui.text.UITextField;

	
	import flash.display.Sprite;
	import flash.events.Event;

	import com.demonsters.debugger.MonsterDebugger;


	/**
	 * Exemple d'utilisation Singleton et Display Object.
	 * 
	 * 
	 * @author Matthieu
	 */
	public class MainException extends Sprite
	{		
		private var oPointXY:Point;// position du champ texte
		
		
		public function MainException() 
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}


		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "test classe point");		
			
																
			// construction de la page
			this.setupUI();	
			
			this.erreurCapture();
		}




		/**
		 * Capture des erreurs pendant l'exécution de l'application.
		 * 
		 */
		private function erreurCapture() : void
		{
			var aTableauVide:Array;
			//var aTableauVide:Array = new Array();// écriture correcte
			
			try
			{
				aTableauVide.push("Bonjour");	
			}
			catch(error:Error)
			{
				MonsterDebugger.trace(this, "L'objet tableau n'a pas été initialisé ! "+error.message);// affiche le message et continue l'exécution du code	
			}
			finally
			{
				MonsterDebugger.trace(this, "Instruction exécutée dans tous les cas ;)");	
			}
			
			// personnalisation des messages d'erreurs
			try 
            { 
                if ( !aTableauVide ) 
                { 
                    throw new Error("Le tableau n'a pas été initialisé");// envoie ce message à catch 
                } 
				aTableauVide.push("Bonjour");	
            }  
            catch (error:Error) 
            {
				var oText:UITextField = this.addText( "ERREUR : "+error.message, oPointXY);
				this.addChild(oText);
            } 
			
			
			// personnalisation des erreurs
			try 
            { 
                if ( !aTableauVide ) 
                { 
                    throw new AppliError("Err perso : Tableau vide !");// envoie ce message à catch 
                } 
				aTableauVide.push("Bonjour");	
            }  
            catch (error:AppliError) 
            {
				var oTextError:DisplayObject = error.showError(oPointXY);
				this.addChild(oTextError);
            } 			
			
		}
		
		
		
		/**
		 * Création d'un bouton.
		 * 
		 */
		private function setupUI():void
		{
			oPointXY = new Point(10, 50);
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Gooo !";
			oBtnStart.getObject().x = 230;
			oBtnStart.getObject().y = 10;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onAddText );
			this.addChild(oBtnStart);	
			

		}
		
		
		/**
		 * Lance l'affichage des interfaces avec le debug.
		 * 
		 */
		private function onAddText(event : MouseEvent) : void
		{
			var oText:UITextField = this.addText( "Du texte en exemple...", oPointXY);
			this.addChild(oText);
			
			
			// le texte de debug par dessus totu le reste
			var oTextDebug:UITextField = this.addText( "Coucou, c'est moi le debug !", oPointXY);
			this.addChild(oTextDebug);
			
			// un autre texte
			var oTextAutre:UITextField = this.addText( "Et encore un texte.", oPointXY);
			this.addChild(oTextAutre);

		}
		
				
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String, oPoint:Point) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = true;
			oTxtField.multiline = true;// plusieurs lignes dans le champ texte
			oTxtField.autoSizeLeft();
			
			/* Passage par référence  */
			var oCoord:Point = oPoint;// dans ce cas là, les coordonnées de oPoint sont passées comme une référence à l'objet oCoord
			oTxtField.x = oCoord.x;// les textes sont les uns sous les autres
			oTxtField.y = oCoord.y;
			oCoord.y += 80;// modifie donc les valeurs de oPoint
			
			
			/* passage par copie de valeurs *
			var oCoord:Point = new Point( oPoint.x, oPoint.y);// dans ce cas là, les coordonnées de oPoint sont passées comme une valeur
			oTxtField.x = oCoord.x;
			oTxtField.y = oCoord.y;// les textes sont empilés les uns sur les autres
			oCoord.y += 80;// modifie donc les valeurs de oCoord
			*/
			
			
			
			oTxtField.maxHeight = oTxtField.height = 100;
			
			oTxtField.background = true;
			oTxtField.backgroundColor = Math.random()*0xffffff;
			
			oTxtField.changeFormat("size", 28);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", Math.random()*0X006f77);// changement de la couleur
			
			return oTxtField;	 
		}
	
	
	}
}
